 ###############################################
#                                               #
#    P U B L I C   Q U O T E S   S Y S T E M    #
#      v1.4 (03/06/2010)  2010 MenzAgitat      #
#                                               #
#        IRC:  irc.epiknet.org  #boulets        #
#          http://www.boulets-roxx.com          #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.eggdrop.fr              #
#        ou  http://www.egghelp.org             #
#                                               #
#-----------------------------------------------#
# Remerciements  Galdinx pour les nombreux     #
# coups de main et  tous les autres pour le    #
# beta testing.                                 #
 ###############################################

#
# Changelog :
#		0.01a (pre-release alpha)
#		0.02b (pre-release beta)
#			- Ajout d'un antiflood individuel (sur chaque commande publique).
#			- Ajout d'un antiflood global (toutes commandes publiques confondues).
#			- Ajout d'un antiflood sur les messages d'avertissement de l'antiflood.
#			- correction de failles de scurit.
#		0.03RC1 (release candidate 1)
#			- Ajout d'une fonction de backup automatique des bases de donnes.
#			- Ajout d'une fonction de restauration automatique d'un backup
#				si la base de donnes est manquante et qu'un backup existe.
#		1.0
#			- Ajout d'une option de recherche globale pour la commande findquote
#				(paramtre -all).
#		1.1
#			- Correction d'une faille de scurit.
#		1.2
#			- Reconnaissance du mode +c (filtrage de la couleur, gras, soulign) :
#				tous les affichages passent automatiquement en monochromie et tous
#				les codes de contrle sont limins si ce mode est dtect sur un chan.
#		1.21 (ne concerne que la version anglaise)
#		1.22
#			- Correction d'un bug mineur dans le message de log lors du backup des
#				bases de donnes.
#		1.3
#			- Quelques corrections esthtiques
#			- Correction d'un bug avec !findquote : le caractre pipe faisait
#				malencontreusement partie des caractres interdits.
#			- Ajout de la commande !cancelquote qui permet d'annuler la dernire
#				citation enregistre.
#			- Ajout de nouveaux paramtres rglables dans la section configuration.
#		1.31
#			- Correction d'un bug empchant la procdure de dsinstallation avant
#				rehash de fonctionner.
#		1.32
#			- La commande !deletedquoteinfo envoie maintenant les informations en
#				notice.
#			- Les chans dont le nom comporte des caractres spciaux sont maintenant
#				supports.
#		1.4
#			- Restructuration de la quasi-totalit du code; correction de nombreux
#				bugs.
#			- L'activation/dsactivation de Public Quotes System sur chaque chan se
#				fait dsormais via la commande .chanset #chan +/-pubqsys en partyline.
#				Si vous mettez  jour depuis une ancienne version, vous devrez le
#				ractiver manuellement sur chaque chan.
#			- Ajout d'un paramtre de chan pour autoriser ou non le bot  afficher une
#				citation alatoire  intervalles rguliers. Vous pouvez
#				activer/dsactiver cette fonctionnalit chan par chan en tapant :
#				.chanset #nomduchan +/-autorandquote
#			- La consommation de mmoire a t rduite.
#			- La structure des bases de donnes a t modifie. La conversion de vos
#				anciennes bases de donnes est automatique, nul besoin de vous en
#				proccuper. Si une conversion est ncessaire, le script cre une copie
#				de sauvegarde des bases de donnes dans un fichier quotes.nomduchan.old
#				avant de procder.
#			- Lors d'une recherche avec !findquote, les caractres accentus peuvent
#				tre crits indiffremment avec ou sans accent.
#

#
# Description :
# Ce script ajoute les commandes suivantes :
#		!addquote <citation>
#			Enregistre une citation.
#		!quote <n de citation> [#chan]
#			Affiche une citation.
#		!quoteinfo <n de citation> [#chan]
#			Affiche des informations sur une citation.
#		!delquote <n de citation>
#			Efface une citation.
#		!randquote [#chan]
#			Affiche une citation alatoire.
#		!lastquote [#chan]
#			Affiche la dernire citation enregistre.
#		!findquote [-all/#chan] <argument(s) de recherche>
#			Recherche une citation. Mettez des " " autour de vos arguments de
#			recherche pour rechercher l'expression exacte. Utilisez le paramtre -all
#			pour effectuer une recherche globale dans les bases de donnes de TOUS les
#			chans OU prcisez le chan sur lequel vous souhaitez effectuer la recherche.
#			Les caractres ? et * ne font pas office de jokers et sont matchs
#			littralement.
#		!deletedquoteinfo <n de citation>
#			Affiche des informations sur une citation efface (commande admin).
#		!undelquote <n de citation>
#			Restaure une citation efface (commande admin).
#		!forcedelquote <n de citation>
#			Efface une citation mme si vous n'en tes pas l'auteur (commande admin).
#		!cancelquote <n de la dernire citation>
#			Annule la dernire quote ajoute sur le chan en cours; n'en laisse aucune
#			trace dans la base de donnes (commande admin).
# Commandes de Partyline :
#		.chanset #nomduchan <+/-> pubqsys
#			Active/dsactive les citations sur un chan.
#		.chanset #nomduchan <+/-> autorandquote
#			Active/dsactive l'affichage automatique d'une citation alatoire 
#			intervalles rguliers sur un chan. Ce rglage est indpendant du prcdent
#			et il est tout  fait possible d'activer les quotes alatoires sur un
#			chan o les citations ne sont pas actives.
#
# Inutile de prciser que les commandes !forcedelquote et !cancelquote doivent tre
# utilises avec thique, pour des oprations de maintenance ou pour faire face  un
# abus de la part des usagers notamment.
#
# Un rpertoire nomm quotes.db sera automatiquement cr dans le rpertoire de
# l'eggdrop. Il contiendra les bases de donnes de citations.
#
# Et n'oubliez pas, pour activer les citations sur un chan, vous devez taper :
#		.chanset #nomduchan +pubqsys
#

#
# LICENCE:
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#

if {[info commands pubqsys::uninstall] eq "::pubqsys::uninstall"} { pubqsys::uninstall }
# Note pour les programmeurs :
# Dans la version 1.6.19 d'eggdrop, le numro de version affich par .vbottree
# et [numversion] est incorrect; il affiche 1061800 ou 1061801, ce qui
# correspond  la version 1.6.18. On utilise donc une autre technique pour
# vrifier le numro de version.
if { [join [split [string range [lindex $version 0] 0 5] "."] ""] < 1619 } { putloglev o * "\00304\002\[Public Quotes System - ERREUR\]\002\003 La version de votre eggdrop est \00304\002$version\002\003; \002Public Quotes System\002 ne fonctionnera correctement que sur les eggdrops version 1.6.19 ou suprieure." ; return }
if { [info tclversion] < 8.5 } { putloglev o * "\00304\002\[Public Quotes System - ERREUR\]\002\003 \Public Quotes System\002 ncessite que Tcl 8.5 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.5
namespace eval pubqsys {

############################
#      CONFIGURATION       #
############################

	#### COMMANDES ET AUTORISATIONS

	# Commande utilise pour afficher une citation
	variable quotecmd "!quote"
	# autorisations pour la commande !quote
	variable quoteauth "-|-"

	# Commande utilise pour ajouter une citation 
	variable addquotecmd "!addquote"
	# autorisations pour la commande !addquote
	variable addquoteauth "-|-"

	# Commande utilise pour afficher des informations sur une citation 
	variable quoteinfocmd "!quoteinfo"
	# autorisations pour la commande !quoteinfo
	variable quoteinfoauth "-|-"

	# Commande utilise pour effacer une citation
	variable delquotecmd "!delquote"
	# autorisations pour la commande !delquote
	variable delquoteauth "-|-"

	# Commande utilise pour afficher une citation alatoire
	variable randquotecmd "!randquote"
	# autorisations pour la commande !randquote
	variable randquoteauth "-|-"

	# Commande utilise pour afficher la dernire citation en date
	variable lastquotecmd "!lastquote"
	# autorisations pour la commande !lastquote
	variable lastquoteauth "-|-"

	# Commande utilise pour rechercher une citation
	variable findquotecmd "!findquote"
	# autorisations pour la commande !findquote
	variable findquoteauth "-|-"

	# Commande utilise pour afficher des informations sur une citation efface
	variable deletedquoteinfocmd "!deletedquoteinfo"
	# autorisations pour la commande !deletedquoteinfo
	variable deletedquoteinfoauth "nm|nm"

	# Commande utilise pour restaurer une citation efface
	variable undelquotecmd "!undelquote"
	# autorisations pour la commande !undelquote
	variable undelquoteauth "nm|nm"

	# Commande utilise pour effacer une citation (modration administrateur)
	variable forcedelquotecmd "!forcedelquote"
	# autorisations pour la commande !forcedelquote
	variable forcedelquoteauth "nm|nm"

	# Commande utilise pour annuler la dernire citation enregistre
	variable cancelquotecmd "!cancelquote"
	# autorisations pour la commande !cancelquote
	variable cancelquoteauth "nm|nm"


	#### PARAMETRES DE RECHERCHE

	# Nombre maximum de citations rcentes  afficher pour !findquote
	variable maxfindquote 2

	# Nombre maximum de rsultats que le la commande !findquote est
	# autorise  grer. Si vous limitez par exemple  100 et qu'une
	# recherche renvoie plus de 100 rsultats, il sera demand 
	# l'utilisateur de prciser sa recherche en raison du trop grand
	# nombre de rsultats. Si vous ne souhaitez pas imposer de limite,
	# mettez 0.
	variable maxfindquotetotal 100


	#### PARAMETRES DE L'ANTI-FLOOD

	# Anti-flood (0 = dsactiv, 1 = activ)
	variable antiflood 1

	# Contrle anti-flood individuel
	# "6:30" = 6 commandes maximum en 30 secondes; les suivantes seront ignores.
	variable cmdflood_addquote "3:80"
	variable cmdflood_quote "5:80"
	variable cmdflood_quoteinfo "5:80"
	variable cmdflood_delquote "2:60"
	variable cmdflood_randquote "5:80"
	variable cmdflood_lastquote "2:60"
	variable cmdflood_findquote "3:80"

	# Contrle anti-flood global (toutes commandes confondues)
	# remarque : pour le nombre de commandes, spcifiez une valeur suprieure 
	#            la plus grande valeur dfinie pour le contrle de flood
	#            individuel.
	variable cmdflood_global "10:120"

	# Intervalle de temps minimum entre l'affichage de 2 messages
	# avertissant que l'anti-flood a t dclench (ne rglez pas
	# cette valeur trop bas afin de ne pas tre flood par les messages
	# d'avertissement de l'anti-flood...)
	variable antiflood_msg_interval 20


	#### PARAMETRES DIVERS
	
	# Par dfaut, il ne vous est pas possible d'afficher les citations d'un chan
	# sur lequel Public Quotes System est dsactiv ou si l'eggdrop ne se trouve
	# pas dessus; il est nanmoins possible de contourner cette limitation en
	# incluant ce(s) chan(s) dans le paramtre suivant. Pour dfinir plusieurs
	# chans, sparez-les par un espace.
	# exemple : {#chan1 #chan2 #chan3} ou {#chan1}
	# attention, si le nom du chan contient le caractre } ou { , vous devez
	# le remplacer par \} ou \{. exemple : si votre chan s'appelle #mon{chan},
	# mettez #mon\{chan\}.
	variable include_chans {}

	# longueur maximale d'une ligne affichable (varie d'un serveur IRC  l'autre)
	variable max_line_length 430
	
	# A quel intervalle en minutes doit-on afficher automatiquement une citation
	# alatoire ? (si l'option est active, voir syntaxe plus haut)
	variable autorandquote_interval 60

	# Rpertoire contenant les bases de donnes (chemin absolu si commenant
	# par "/", ou relatif en partant du rpertoire de base de l'eggdrop sinon).
	variable db_path "quotes.db"

	# Rpertoire contenant les sauvegardes des bases de donnes (chemin absolu
	# si commenant par "/", ou relatif en partant du rpertoire de base de
	# l'eggdrop sinon).
	variable backup_path "quotes.db"

	# Heure de la sauvegarde quotidienne des bases de donnes.
	variable backuptime "00:00"





####################################################################
#                                                                  #
#   DO NOT MODIFY ANYTHING BELOW THIS BOX IF YOU DON'T KNOW TCL    #
#                                                                  #
# NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE CONNAISSEZ PAS LE TCL #
#                                                                  #
####################################################################

	variable scriptname "Public Quotes System"
	variable version "1.4.20100603"
	setudef flag pubqsys
	setudef flag autorandquote
	variable floodsettingsstring [split "global $cmdflood_global addquote $cmdflood_addquote quote $cmdflood_quote quoteinfo $cmdflood_quoteinfo delquote $cmdflood_delquote randquote $cmdflood_randquote lastquote $cmdflood_lastquote findquote $cmdflood_findquote"]
	variable floodsettings ; array set floodsettings $floodsettingsstring
	variable instance ; array set instance {}
	variable antiflood_msg ; array set antiflood_msg {}
	variable backuptime [split $backuptime ":"]
	# Procdure de dsinstallation
	# (le script se dsinstalle totalement avant chaque rehash ou  chaque relecture au moyen de la commande "source" ou autre)
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$pubqsys::scriptname\002..."
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " \{?(::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		foreach running_timer [timers] {
			if { [string match "*[namespace current]::*" [lindex $running_timer 1]] } { killtimer [lindex $running_timer 2] }
		}
		foreach running_utimer [utimers] {
			if { [string match "*[namespace current]::*" [lindex $running_utimer 1]] } { killutimer [lindex $running_utimer 2] }
		}
		namespace delete ::pubqsys
	}
}

###
### !quote <n de citation> [#chan]
###
proc pubqsys::quote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "quote"] eq "flood"))} {
		return
	}
	set arg [split $arg]
	if {([llength $arg] < 1) || ([llength $arg] > 2) || (![regexp {^[0-9]+$} [lindex $arg 0]]) || (([llength $arg] == 2) && ([string first # [lindex $arg 1]] != 0))} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::quotecmd[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]> \[[code endcolor $chan]#chan[code 14 $chan]\][code endcolor $chan]"
		return
	} elseif {([string first "#" [set place [lindex $arg 1]]] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![validchan $place])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : $place n'est pas un chan valide."
		return
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![channel get $place pubqsys])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Les citations ne sont pas actives sur le chan $place."
		return
	} else {
		if {$place eq ""} {
			set channame [string replace $chan 0 0]
			set quotenumber [string trimleft $arg "0"]
		} else {
			set channame [string replace $place 0 0]
			set quotenumber [string trimleft [lindex $arg 0] "0"]
		}
		set clean_channame [pubqsys::clean_data $channame]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		if { [pubqsys::read_quotes $chan $channame "quote"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [split [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]]
	}
	if {[set index1 [string trimleft [lindex $quote 0] "0"]] == $quotenumber} {
		puthelp "PRIVMSG $chan :\[[code bold $chan][code underline $chan]$quotenumber[code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 5 end]] $chan]"
	} elseif {$index1 eq "-deleted-"} {
		if {[string match *(admin)* [set whodel [lindex $quote 1]]] == 1} { set whodel "un administrateur" }
		if {[lindex $quote 2] eq "00/00/0000"} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe plus."
		} else {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe plus, elle a t supprime par $whodel le [lindex $quote 2]  [lindex $quote 3]."
		}
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !addquote <citation>
###
proc pubqsys::addquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "addquote"] eq "flood"))} {
		return
	} elseif {$arg eq ""} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::addquotecmd[code bold $chan] [code 14 $chan]<[code endcolor $chan]citation[code 14 $chan]>[code endcolor $chan]"
	} elseif {([string length $arg] < 10) || ([llength [split $arg]] < 3)} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Vous ne pouvez pas enregistrer des citations de moins de 10 caractres ni de moins de 3 mots."
	} else {
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		pubqsys::read_quotes $chan $channame "addquote"
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		set quote "[format %09g [expr $numquotes + 1]] [strftime "%d/%m/%Y %H:%M:%S" [unixtime]] $chan $nick [encoding convertto identity $arg]"
		lappend ::pubqsys::quoteslist($clean_channame) $quote
		pubqsys::write_quotes $channame
		puthelp "PRIVMSG $chan :Citation n[expr $numquotes + 1] ajoute."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !quoteinfo <n de citation> [#chan]
###
proc pubqsys::quoteinfo {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "quoteinfo"] eq "flood"))} {
		return
	}
	set arg [split $arg]
	if {([llength $arg] < 1) || ([llength $arg] > 2) || (![regexp {^[0-9]+$} [lindex $arg 0]]) || (([llength $arg] == 2) && ([string first # [lindex $arg 1]] != 0))} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::quoteinfocmd[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]> \[[code endcolor $chan]#chan[code 14 $chan]\][code endcolor $chan]"
		return
	} elseif {([string first "#" [set place [lindex $arg 1]]] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![validchan $place])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : $place n'est pas un chan valide."
		return
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![channel get $place pubqsys])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Les citations ne sont pas actives sur le chan $place."
		return
	} else {
		if {$place eq ""} {
			set channame [string replace $chan 0 0]
			set quotenumber [string trimleft $arg "0"]
		} else {
			set channame [string replace $place 0 0]
			set quotenumber [string trimleft [lindex $arg 0] "0"]
		}
		set clean_channame [pubqsys::clean_data $channame]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		if { [pubqsys::read_quotes $chan $channame "quoteinfo"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [split [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]]
	}
	if {[set index1 [string trimleft [lindex $quote 0] "0"]] == $quotenumber} {
		if {[lindex $quote 1] eq "00/00/0000"} {
			puthelp "PRIVMSG $chan :La citation n$quotenumber a t enregistre par [join [split [lindex $quote 4]]]."
		} else {
			puthelp "PRIVMSG $chan :La citation n$quotenumber a t enregistre par [join [split [lindex $quote 4]]] le [lindex $quote 1]  [lindex $quote 2]."
		}
	} elseif {$index1 eq "-deleted-"} {
		if {[lindex $quote 2] eq "00/00/0000"} {
			puthelp "PRIVMSG $chan :Les informations ne sont pas disponibles."
		} else {
			if {[string match *(admin)* [set whodel [lindex $quote 1]]] == 1} { set whodel "un administrateur" }
			puthelp "PRIVMSG $chan :La citation n$quotenumber n'existe plus, elle a t supprime par $whodel le [lindex $quote 2]  [lindex $quote 3]."
		}
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !delquote <n de citation>
###
proc pubqsys::delquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "delquote"] eq "flood"))} {
		return
	} elseif {![regexp {^[0-9]+$} $arg]} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::delquotecmd[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]>[code endcolor $chan]  (vous devez en tre l'auteur)"
		return
	} else {
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		set quotenumber [string trimleft $arg "0"]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		if { [pubqsys::read_quotes $chan $channame "delquote"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]
	}
	if {[set index1 [string trimleft [lindex $quote 0] "0"]] == $quotenumber} {
		if {[set author [lindex [split $quote] 4]] != $nick} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Vous n'tes pas autoris  effacer cette citation. Son auteur est [code bold $chan]$author[code bold $chan]."
			array unset ::pubqsys::quoteslist ; return
		}
		set deletedquote "-deleted- $nick [strftime %d/%m/%Y [unixtime]] [strftime %H:%M:%S [unixtime]] $chan -------- $nick!$host a effac : $quote"
		set ::pubqsys::quoteslist($clean_channame) [lreplace $::pubqsys::quoteslist($clean_channame) [set index2 [expr $quotenumber - 1]] $index2 $deletedquote]
		pubqsys::write_quotes $channame
		puthelp "PRIVMSG $chan :Citation n$quotenumber efface."
	} elseif {$index1 eq "-deleted-"} {
		if {[string match *(admin)* [set whodel [lindex [split $quote] 1]]] == 1} { set whodel "un administrateur" }
		if {[lindex $quote 2] eq "00/00/0000"} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe plus, elle a dj t supprime."
		} else {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe plus, elle a dj t supprime par $whodel le [lindex $quote 2]  [lindex $quote 3]."
		}
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !randquote [#chan]
###
proc pubqsys::randquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "randquote"] eq "flood"))} {
		return
	}
	set arg [split $arg]
	if {(([string first "#" [set place [lindex $arg 0]]] != 0) || ([llength $place] > 1)) && ($place ne "")} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::randquotecmd[code bold $chan] [code 14 $chan]\[[code endcolor $chan]#chan[code 14 $chan]\][code endcolor $chan]"
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![validchan $place])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : $place n'est pas un chan valide."
		return
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![channel get $place pubqsys])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Les citations ne sont pas actives sur le chan $place."
		return
	} else {
		if {[lindex $arg 0] eq ""} {
			set channame [string replace $chan 0 0]
		} else {
			set channame [string replace $place 0 0]
		}
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "randquote"] eq "missing" } { return }
		set existingquotes [lsearch -all -inline -regexp $::pubqsys::quoteslist($clean_channame) {^(?!-deleted-(.*))}]
		set numquotes [llength $existingquotes]
		if {$numquotes == 0} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Aucune citation valide n'a t trouve."
			array unset ::pubqsys::quoteslist ; return
		}
		set quote [split [lindex $existingquotes [rand $numquotes]]]
		puthelp "PRIVMSG $chan :\[[code bold $chan][code underline $chan][string trimleft [lindex $quote 0] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 5 end]] $chan]"
		array unset ::pubqsys::quoteslist ; return
	}
}

###
### Affichage automatique d'une citation alatoire  intervalles rguliers
###
proc pubqsys::autorandquote {} {
	foreach chan [channels] {
		if {[channel get $chan autorandquote]} {
			set channame [string replace $chan 0 0]
			set clean_channame [pubqsys::clean_data $channame]
			if { [pubqsys::read_quotes $chan $channame "autorandquote"] eq "missing" } { continue }
			set existingquotes [lsearch -all -inline -regexp $::pubqsys::quoteslist($clean_channame) {^(?!-deleted-(.*))}]
			set numquotes [llength $existingquotes]
			if {$numquotes == 0} { continue }
			set quote [split [lindex $existingquotes [rand $numquotes]]]
			puthelp "PRIVMSG $chan :\[[code bold $chan][code underline $chan][string trimleft [lindex $quote 0] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 5 end]] $chan]"
		}
	}
	array unset ::pubqsys::quoteslist
	timer $pubqsys::autorandquote_interval ::pubqsys::autorandquote
	return
}

###
### !lastquote [#chan]
###
proc pubqsys::lastquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "lastquote"] eq "flood"))} {
		return
	}
	set arg [split $arg]
	if {(([string first "#" [set place [lindex $arg 0]]] != 0) || ([llength $arg] > 1)) && ($arg ne "")} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::lastquotecmd[code bold $chan] [code 14 $chan]\[[code endcolor $chan]#chan[code 14 $chan]\][code endcolor $chan]"
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![validchan $place])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : $place n'est pas un chan valide."
		return
	} elseif {([string first "#" $place] == 0) && ([lsearch -exact $pubqsys::include_chans $place] == -1) && (![channel get $place pubqsys])} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Les citations ne sont pas actives sur le chan $place."
		return
	} else {
		if {$place eq ""} {
			set channame [string replace $chan 0 0]
		} else {
			set channame [string replace $place 0 0]
		}
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "lastquote"] eq "missing" } { return }
		set existingquotes [lsearch -all -inline -regexp $::pubqsys::quoteslist($clean_channame) {^(?!-deleted-(.*))}]
		set numexistingquotes [llength $existingquotes]
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		set lastrawquote [split [lindex $::pubqsys::quoteslist($clean_channame) [expr $numquotes - 1]]]
		if {$numquotes == 0} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Aucune citation valide n'a t trouve."
			array unset ::pubqsys::quoteslist ; return
		}
		if {[lindex $lastrawquote 0] eq "-deleted-"} {
			if {[string match *(admin)* [set whodel [lindex $lastrawquote 1]]] == 1} { set whodel "un administrateur" }
			puthelp "PRIVMSG $chan :La dernire citation en date (n$numquotes) n'existe plus, elle a t supprime par $whodel le [lindex $lastrawquote 2]  [lindex $lastrawquote 3]. Recherche de la dernire citation valide..."
		}
		set quote [split [lindex $existingquotes [expr $numexistingquotes - 1]]]
		puthelp "PRIVMSG $chan :\[[code bold $chan][code underline $chan][string trimleft [lindex $quote 0] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 5 end]] $chan]"
		array unset ::pubqsys::quoteslist ; return
	}
}

###
### !findquote [-all/#chan] <argument(s) de recherche>
###
proc pubqsys::findquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {($pubqsys::antiflood == 1) && (([pubqsys::antiflood $chan "global"] eq "flood") || ([pubqsys::antiflood $chan "findquote"] eq "flood"))} {
		return
	}
	set arg [split $arg]
	if { ([lindex $arg 0] eq "-all") || (([string first "#" [lindex $arg 0]] == 0) && ([lindex $arg 1] ne "")) } {
		set place [lindex $arg 0]
		set search_arguments [join [lrange $arg 1 end]]
	} else {
		set place $chan
		set search_arguments [join $arg]
	}
	if {($arg eq "") || (($place eq "-all") && ($search_arguments eq ""))} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]$pubqsys::findquotecmd[code bold $chan] [code 14 $chan]\[[code endcolor $chan]-all[code 14 $chan]/[code endcolor $chan]#chan[code 14 $chan]\] <[code endcolor $chan]critres de recherche[code 14 $chan]>  [code 07 $chan]|[code endcolor $chan] Utilisez des guillemets pour faire une recherche exacte. [code underline $chan]Exemples[code underline $chan] : [code bold $chan]$pubqsys::findquotecmd un test[code bold $chan] (trouve toutes les citations qui contiennent le mot [code bold $chan]un[code bold $chan] [code underline $chan]et[code underline $chan] le mot [code bold $chan]test[code bold $chan]).  [code bold $chan]$pubqsys::findquotecmd \"un test\"[code bold $chan] (trouve toutes les citations qui contiennent exactement \"[code bold $chan]un test[code bold $chan]\").[code endcolor $chan]"
		return
	} elseif {([string first "#" $place] == 0) && ($search_arguments ne "") && (((![validchan $place]) || (([validchan $place]) && (![channel get $place pubqsys]))) && ([lsearch -exact $pubqsys::include_chans $place] == -1))} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Les citations ne sont pas actives sur le chan [join [lindex $arg 0]]."
		return
	} elseif {[expr ([set is_even [regsub -all {\"} $search_arguments "" dummy]] / 2) * 2] != $is_even} {  ; #"
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Vous utilisez un nombre impair de guillemets dans vos arguments de recherche. Les guillemets permettent de faire une recherche exacte et doivent s'utiliser par paires. [code underline $chan]Exemple[code underline $chan] : [code bold $chan]$pubqsys::findquotecmd \"un test\"[code bold $chan]"
		return
	} elseif {[regexp {""} $search_arguments] != 0} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Vous avez utilis [code bold $chan]\"\"[code bold $chan] dans vos arguments de recherche; cela reprsente une recherche exacte vide et la commande [code bold $chan]$pubqsys::findquotecmd[code bold $chan] ne le permet pas. Vous devez inclure du texte entre les guillemets. [code underline $chan]Exemple[code underline $chan] : [code bold $chan]$pubqsys::findquotecmd \"un test\"[code bold $chan]"
		return
	} elseif {([string length $search_arguments] < 3) || ((([string first # $place] == 0) || ($place eq "-all")) && ([string length $search_arguments] < 3))} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Votre recherche doit comporter au moins 3 caractres."
		return
	} elseif {[regexp {[\{\}\\]} $search_arguments] != 0} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Vous ne pouvez pas utiliser les caractres suivants dans les arguments de recherche de la commande $pubqsys::findquotecmd : [code bold $chan]\{ \} \\[code bold $chan]"
		return
	}
	set channame [string map {"#" ""} $place]
	set clean_channame [pubqsys::clean_data $channame]
	# chargement des bases de donnes concernes par la recherche
	if {$place ne "-all"} {
		if { [pubqsys::read_quotes $chan $channame "findquote"] eq "missing" } { return }
	} else {
		set ::pubqsys::quoteslist(-all) ""
		set chanlist [concat [channels] $pubqsys::include_chans]
		foreach channameall $chanlist {
			set channameall [string replace $channameall 0 0]
			set clean_channameall [pubqsys::clean_data $channameall]
			if {[file exists "$pubqsys::db_path/quotes.$clean_channameall"]} {
				variable quotesfile [open "$pubqsys::db_path/quotes.$clean_channameall" r]
				set ::pubqsys::quoteslist(-all) "$::pubqsys::quoteslist(-all) [split [read -nonewline $quotesfile] \n]"
				close $quotesfile
			}
		}
		if {$::pubqsys::quoteslist(-all) eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Aucune base de donnes n'est disponible pour effectuer la recherche."
			array unset ::pubqsys::quoteslist ; return
		}
	}
	# filtrage des rsultats en fonction des critres de recherche
	set filtered_quotes $::pubqsys::quoteslist($clean_channame)
	foreach element $search_arguments {
		set filtered_quotes_bad_indexes [lsort -decreasing -integer [lsearch -all -not -nocase [pubqsys::filter_accents $filtered_quotes] "????????? ??/??/???? ??:??:?? #* * *[string map {{?} {\?} {*} {\*}} [pubqsys::filter_accents $element]]*"]]
		foreach bad_index $filtered_quotes_bad_indexes {
			set filtered_quotes [lreplace $filtered_quotes $bad_index $bad_index]
		}
	}
	set numresults [llength $filtered_quotes]
	if {$numresults == 0} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] La recherche n'a rien donn."
		array unset ::pubqsys::quoteslist ; return
	} elseif {$numresults == 1} {
		if {$channame ne "-all"} {
			puthelp "PRIVMSG $chan :[code underline $chan]$numresults rsultat a t trouv[code underline $chan] :"
		} else {
			puthelp "PRIVMSG $chan :[code underline $chan]$numresults rsultat a t trouv sur [lindex [split [join $filtered_quotes]] 3][code underline $chan] :"
		}
	} elseif {($numresults > $pubqsys::maxfindquotetotal) && ($pubqsys::maxfindquotetotal != 0)} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] La recherche a donn plus de $pubqsys::maxfindquotetotal rsultats ($numresults prcisment). Essayez d'tre plus prcis afin d'en limiter le nombre."
		array unset ::pubqsys::quoteslist ; return
	} else {
		if {$channame ne "-all"} {
			set foundquotenumbers "[code underline $chan]$numresults rsultats ont t trouvs[code underline $chan] : "
			set marker 0
			foreach element $filtered_quotes {
				if { !$marker } {
					set foundquotenumbers "$foundquotenumbers[code bold $chan][code bold $chan][string trimleft [lindex [split $element] 0] "0"]"
					set marker 1
				} else {
					set foundquotenumbers "$foundquotenumbers[code 14 $chan]|[code endcolor $chan][code bold $chan][code bold $chan][string trimleft [lindex [split $element] 0] "0"]"
				}
				if {[string length [join $foundquotenumbers]] >= $pubqsys::max_line_length} {
					puthelp "PRIVMSG $chan :$foundquotenumbers"
					set foundquotenumbers ""
				}
			}
			if {$foundquotenumbers ne ""} {
				puthelp "PRIVMSG $chan :$foundquotenumbers"
			}
		} else {
			set resultchanlist ""
			foreach element $filtered_quotes {
				set element [split $element]
				set resultchanlist [concat $resultchanlist [lindex $element 3]]
				lappend chronolist "[lindex [set date [split [lindex $element 1] "/"]] 2][lindex $date 1][lindex $date 0][join [split [lindex $element 2] ":"] ""] [lindex $element 0] [join [lrange $element 3 end]]"
			}
			set chronolist [lsort $chronolist]
			set resultchanlist [join [lsort -unique -nocase [split $resultchanlist]]]
			puthelp "PRIVMSG $chan :[code underline $chan]$numresults rsultats ont t trouvs sur les chans suivants[code underline $chan] : $resultchanlist"
			puthelp "PRIVMSG $chan :[code underline $chan]Citations rcentes[code underline $chan] :"
			for { set counter 0 } { ($counter < $pubqsys::maxfindquote) && ($counter < $numresults) } { incr counter } {
				set quote [split [lindex $chronolist [expr $numresults - ($counter + 1)]]]
				puthelp "PRIVMSG $chan :[code 14 $chan][lindex $quote 2][code endcolor $chan] \[[code bold $chan][code underline $chan][string trimleft [lindex $quote 1] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lreplace $quote 0 3]] $chan]"
			}
			array unset ::pubqsys::quoteslist ; return
		}
		puthelp "PRIVMSG $chan :[code underline $chan]Citations rcentes[code underline $chan] :"
	}
	for { set counter 0 } { ($counter < $pubqsys::maxfindquote) && ($counter < $numresults) } { incr counter } {
		set quote [split [lindex $filtered_quotes [expr $numresults - ($counter + 1)]]]
		puthelp "PRIVMSG $chan :\[[code bold $chan][code underline $chan][string trimleft [lindex $quote 0] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lreplace $quote 0 4]] $chan]"
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !deletedquoteinfo <n de citation>
###
proc pubqsys::deletedquoteinfo {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {![regexp {^[0-9]+$} $arg]} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]!deletedquoteinfo[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]>[code endcolor $chan]"
		return
	} else {
		set quotenumber [string trimleft $arg "0"]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "deletedquoteinfo"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [split [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]]
	}
	if {[string trimleft [set index1 [lindex $quote 0]] "0"] == $quotenumber} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber existe."
	} elseif {$index1 eq "-deleted-"} {
		if {[string match *(admin)* [set whodel [lindex $quote 1]]] == 1} { set whodel "un administrateur" }
		if {[lindex $quote 2] eq "00/00/0000"} {
			puthelp "PRIVMSG $chan :Les informations ne sont pas disponibles."
		} elseif { [lindex $quote 5] eq "" } {
			puthelp "NOTICE $nick :La citation n$quotenumber a t supprime par $whodel le [lindex $quote 2]  [lindex $quote 3]."
		} else {
			puthelp "NOTICE $nick :La citation n$quotenumber a t supprime par $whodel ([join [split [lindex $quote 6]]]) le [lindex $quote 2]  [lindex $quote 3]. Cette citation avait t enregistre par [join [split [lindex $quote 14]]] le [lindex $quote 11]  [lindex $quote 12]. Voici la citation efface :"
			puthelp "NOTICE $nick :\[[code bold $chan][code underline $chan][string trimleft [lindex $quote 10] "0"][code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 15 end]] $chan]"
		}
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !undelquote <n de citation>
###
proc pubqsys::undelquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {![regexp {^[0-9]+$} $arg]} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]!undelquote[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]>[code endcolor $chan]"
		return
	} else {
		set quotenumber [string trimleft $arg "0"]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "undelquote"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]
	}
	if {[set index1 [lindex [split $quote] 0]] == $quotenumber} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation existe et n'a pas besoin d'tre restaure."
	} elseif {$index1 eq "-deleted-"} {
		set restoredquote [join [lrange [split $quote] 10 end]]
		set ::pubqsys::quoteslist($clean_channame) [lreplace $::pubqsys::quoteslist($clean_channame) [set index2 [expr $quotenumber - 1]] $index2 $restoredquote]
		pubqsys::write_quotes $channame
		puthelp "PRIVMSG $chan :Citation n$quotenumber restaure."
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !forcedelquote <n de citation>
###
proc pubqsys::forcedelquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {![regexp {^[0-9]+$} $arg]} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]!forcedelquote[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la citation[code 14 $chan]>[code endcolor $chan]"
		return
	} else {
		set quotenumber [string trimleft $arg "0"]
		if {$quotenumber eq ""} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : numro de citation invalide."
			return
		}
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "forcedelquote"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $quotenumber > $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe pas encore. ($numquotes citations dans la base de donnes  ce jour)."
			array unset ::pubqsys::quoteslist ; return
		}   
		set quote [lindex $::pubqsys::quoteslist($clean_channame) [expr $quotenumber - 1]]
	}
	if {[string trimleft [set index1 [lindex $quote 0]] "0"] == $quotenumber} {
		set deletedquote "-deleted- $nick[code 04 $chan]\(admin\)[code endcolor $chan] [strftime %d/%m/%Y [unixtime]] [strftime %H:%M:%S [unixtime]] $chan -------- $nick!$host a effac : $quote"
		set ::pubqsys::quoteslist($clean_channame) [lreplace $::pubqsys::quoteslist($clean_channame) [set index2 [expr $quotenumber - 1]] $index2 $deletedquote]
		pubqsys::write_quotes $channame
		puthelp "PRIVMSG $chan :Citation n$quotenumber efface."
	} elseif {$index1 eq "-deleted-"} {
		if {[string match *(admin)* [set whodel [lindex [split $quote] 1]]] == 1} { set whodel "un administrateur" }
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La citation n$quotenumber n'existe plus, elle a dj t supprime par $whodel le [lindex $quote 2]  [lindex $quote 3]."
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### !cancelquote <n de la dernire citation>
###
proc pubqsys::cancelquote {nick host hand chan arg} {
	if {![channel get $chan pubqsys]} {
		return
	} elseif {![regexp {^[0-9]+$} $arg]} {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : La syntaxe correcte est [code bold $chan]!cancelquote[code bold $chan] [code 14 $chan]<[code endcolor $chan]n de la dernire citation[code 14 $chan]>[code endcolor $chan]"
		return
	} else {
		set channame [string replace $chan 0 0]
		set clean_channame [pubqsys::clean_data $channame]
		if { [pubqsys::read_quotes $chan $channame "cancelquote"] eq "missing" } { return }
		set numquotes [llength $::pubqsys::quoteslist($clean_channame)]
		if { $arg != $numquotes } {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Le numro de citation que vous avez tap ne correspond pas  la dernire citation en date. Afin de rduire les risques d'effacement accidentel, vous devez donner le n de la dernire citation."
			array unset ::pubqsys::quoteslist ; return
		}
		set quote [split [lindex $::pubqsys::quoteslist($clean_channame) [expr $numquotes - 1]]]
	}
	if {([string trimleft [lindex $quote 0] "0"] == $numquotes) || (([lindex $quote 0] eq "-deleted-") && ([string trimleft [lindex $quote 10] "0"] == $numquotes))} {
		set ::pubqsys::quoteslist($clean_channame) [lreplace $::pubqsys::quoteslist($clean_channame) [set index2 [expr $numquotes - 1]] $index2]
		pubqsys::write_quotes $channame
		if { [lindex $quote 0] eq "-deleted-" } {
			if {[string match *(admin)* [set whodel [lindex $quote 1]]] == 1} { set whodel "un administrateur" }
			puthelp "PRIVMSG $chan :La dernire citation enregistre a t annule. Cette citation avait t efface par $whodel le [lindex $quote 2]  [lindex $quote 3]."
		} else {
			puthelp "PRIVMSG $chan :La dernire citation enregistre a t annule :"
			puthelp "PRIVMSG $chan :[code 14 $chan]\[[code bold $chan][code underline $chan]$numquotes[code underline $chan][code bold $chan]\] [filtercodes [join [lrange $quote 5 end]] $chan][code endcolor $chan]"
		}
	} else {
		puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Incohrence dtecte dans la base de donnes."
	}
	array unset ::pubqsys::quoteslist ; return
}

###
### Lecture d'une base de donnes de citations
###
proc pubqsys::read_quotes {chan channame command} {
	set clean_channame [pubqsys::clean_data $channame]
	if {(![file exists "$pubqsys::db_path/quotes.$clean_channame"]) && ($command ne "addquote") && ($command ne "autorandquote")} {
		if {[file exists "$pubqsys::db_path/quotes.$clean_channame.bak"]} {
			file copy -force "$pubqsys::backup_path/quotes.$clean_channame.bak" "$pubqsys::db_path/quotes.$clean_channame"
			puthelp "PRIVMSG $chan :[code 04 $chan]::: [code underline $chan]Problme critique[code underline $chan][code endcolor $chan] : La base de donnes de citations de #$channame est introuvable. Une sauvegarde a t trouve et restaure automatiquement."
			putlog "[code 04 $chan]\[Public Quotes System] [code underline $chan]Problme critique[code underline $chan][code endcolor $chan] : La base de donnes de citations de #$channame est introuvable. Une sauvegarde a t trouve et restaure automatiquement."
		} else {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Base de donnes inexistante pour le chan #$channame."
			return "missing"
		}
	}
	if {[file exists "$pubqsys::db_path/quotes.$clean_channame"]} {
		set quotesfile [open "$pubqsys::db_path/quotes.$clean_channame" r]
		set ::pubqsys::quoteslist($clean_channame) [split [read -nonewline $quotesfile] \n]
		close $quotesfile
		if {([llength $::pubqsys::quoteslist($clean_channame)] == 0) && ($command ne "addquote") && ($command ne "autorandquote")} {
			puthelp "PRIVMSG $chan :[code 04 $chan]:::[code endcolor $chan] [code underline $chan]Erreur[code underline $chan] : Il n'y a aucune citation dans la base de donnes de #$channame pour l'instant."
			return "missing"
		# si la base de donnes est  un ancien format, on la convertit
		} else {
			if { [lsearch -regexp $::pubqsys::quoteslist($clean_channame) {^[0-9]+ \(\?\)}] != -1 } {
				set counter 0
				foreach element $::pubqsys::quoteslist($clean_channame) {
					set ::pubqsys::quoteslist($clean_channame) [lreplace $::pubqsys::quoteslist($clean_channame) $counter $counter [string map {"(?) (?) (?)" "(?) 00/00/0000 00:00:00" "(?) (?)" "00/00/0000 00:00:00"} $element]]
					incr counter
				}
			}
			if { [lindex $pubqsys::quoteslist($clean_channame) 0 0] eq "1" } {
				set counter 0
				foreach element $::pubqsys::quoteslist($clean_channame) {
					if { [lindex [split $element] 0] ne "-deleted-" } {
						set ::pubqsys::quoteslist($clean_channame) [lreplace $pubqsys::quoteslist($clean_channame) $counter $counter [join [lreplace [split [lindex $pubqsys::quoteslist($clean_channame) $counter]] 0 0 [format %09g [lindex [split [lindex $pubqsys::quoteslist($clean_channame) $counter]] 0]]]]]
					} elseif { [lindex [split $element] 10] ne "" } {
						set ::pubqsys::quoteslist($clean_channame) [lreplace $pubqsys::quoteslist($clean_channame) $counter $counter [join [lreplace [split [lindex $pubqsys::quoteslist($clean_channame) $counter]] 10 10 [format %09g [lindex [split [lindex $pubqsys::quoteslist($clean_channame) $counter]] 10]]]]]
					}
					incr counter
				}
			}
			if { [info exists counter] } {
				file copy -force "$pubqsys::db_path/quotes.$clean_channame" "$pubqsys::db_path/quotes.$clean_channame.old"
				pubqsys::write_quotes $channame
			}
		}
	} elseif {$command eq "autorandquote"} {
		return "missing"
	} else {
		set ::pubqsys::quoteslist($clean_channame) ""
	}
	return
}

###
### Ecriture d'une base de donnes de citations
###
proc pubqsys::write_quotes {channame} {
	if {![file exists "$pubqsys::db_path"]} { file mkdir "$pubqsys::db_path" }
	set channame [pubqsys::clean_data $channame]
	set quotesfile [open "$pubqsys::db_path/quotes.$channame" w]
	puts $quotesfile [join $::pubqsys::quoteslist($channame) \n]
	close $quotesfile
	return
}

###
### Contrle du flood
###
proc pubqsys::antiflood {chan type} {
	set clean_chan [pubqsys::clean_data $chan]
	if {![info exists ::pubqsys::antiflood_msg($clean_chan$type)]} { set pubqsys::antiflood_msg($clean_chan$type) 0 }
	if {![info exists ::pubqsys::instance($clean_chan$type)]} { set pubqsys::instance($clean_chan$type) 0 }
	set max_instances [lindex [split $pubqsys::floodsettings($type) ":"] 0]
	set instance_length [lindex [split $pubqsys::floodsettings($type) ":"] 1]
	if { $pubqsys::instance($clean_chan$type) >= $max_instances } {
		if { $pubqsys::antiflood_msg($clean_chan$type) == 0 } {
			set pubqsys::antiflood_msg($clean_chan$type) 1
			if {$type ne "global"} {
				putquick "privmsg $chan :[code 04 $chan]:::[code 14 $chan] Contrle de flood activ pour la commande [code bold $chan]!$type[code bold $chan] : pas plus de $max_instances requte(s) toutes les $instance_length secondes.[code endcolor $chan]"
			} else {
				putquick "privmsg $chan :[code 04 $chan]:::[code 14 $chan] Contrle de flood sur les commandes du systme de quotes : pas plus de $max_instances commandes toutes les $instance_length secondes.[code endcolor $chan]"
			}
			utimer $pubqsys::antiflood_msg_interval [list ::pubqsys::antiflood_msg_reset $clean_chan $type]
		}
		return "flood"
	} else {
		incr pubqsys::instance($clean_chan$type)
		utimer $instance_length [list ::pubqsys::antiflood_close_instance $clean_chan $type]
		return "no flood"
	}
}
proc pubqsys::antiflood_close_instance {clean_chan type} {
	if { $pubqsys::instance($clean_chan$type) > 0 } { incr pubqsys::instance($clean_chan$type) -1 }
}
proc pubqsys::antiflood_msg_reset {clean_chan type} {
	set pubqsys::antiflood_msg($clean_chan$type) 0
}

###
### Backup quotidien des bases de donnes
###
proc pubqsys::backup_db {min hour day month year} {
	putlog "\00314\[Public Quotes System\]\003 Sauvegarde des bases de donnes..."
	if {![file exists "$pubqsys::backup_path"]} { file mkdir "$pubqsys::backup_path" }
	foreach channame [channels] {
		if { [channel get $channame pubqsys] } {
			set channame [pubqsys::clean_data [string replace $channame 0 0]]
			if { [file exists "$pubqsys::db_path/quotes.$channame"] } {
				file copy -force "$pubqsys::db_path/quotes.$channame" "$pubqsys::backup_path/quotes.$channame.bak"
			}
		}
	}
}

###
### Gestion des codes de contrle (gras, soulignement, couleurs,...)
###
proc pubqsys::code {code chan} {
	if {$code eq "bold"} {
		if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\002" } { return "" }
	} elseif {$code eq "underline"} {
		if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\037" } { return "" }
	} elseif {$code eq "endcolor"} {
		if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\003" } { return "" }
	} else {
		if {![string match *c* [lindex [split [getchanmode $chan]] 0]]} { return "\003$code" } { return "" }
	}
}

###
### Filtrage des accents pour !findquote
###
proc pubqsys::filter_accents {data} {
	return [string map -nocase {
	"" "a" "" "a" "" "a"
	"" "e" "" "e" "" "e" "" "e"
	"" "i" "" "i"
	"" "o" "" "o"
	"" "u" "" "u" "" "u"
	"" "c" "" "n" "" "a" "" "o"
	} $data]
}

###
### remplacement des caractres spciaux afin de pouvoir tre utiliss dans
### un nom de fichier ou un array sans crer de problmes
###
proc pubqsys::clean_data {data} {
	return [string map {
		"\\" "#01#"
		"\{" "#02#"
		"\}" "#03#"
		"\[" "#04#"
		"\]" "#05#"
		"(" "#06#"
		")" "#07#"
		"|" "#08#"
		"!" "#09#"
		"^" "#10#"
		"`" "#11#"
	} $data]
}

###
### Filtrage des codes de contle contenus dans les citations si le mode +c est actif sur le chan
###
proc pubqsys::filtercodes {data chan} {
	if {[string match *c* [lindex [split [getchanmode $chan]] 0]]} {
		regsub -all -- {\003[0-9]{0,2}(,[0-9]{0,2})?|\017|\037|\002|\026|\006|\007} $data "" data 
	}
	return $data
}

###
### Binds et initialisation des timers
###
namespace eval pubqsys {
	bind pub $pubqsys::quoteauth $pubqsys::quotecmd pubqsys::quote
	bind pub $pubqsys::addquoteauth $pubqsys::addquotecmd pubqsys::addquote
	bind pub $pubqsys::quoteinfoauth $pubqsys::quoteinfocmd pubqsys::quoteinfo
	bind pub $pubqsys::delquoteauth $pubqsys::delquotecmd pubqsys::delquote
	bind pub $pubqsys::randquoteauth $pubqsys::randquotecmd pubqsys::randquote
	bind pub $pubqsys::lastquoteauth $pubqsys::lastquotecmd pubqsys::lastquote
	bind pub $pubqsys::findquoteauth $pubqsys::findquotecmd pubqsys::findquote
	bind pub $pubqsys::deletedquoteinfoauth $pubqsys::deletedquoteinfocmd pubqsys::deletedquoteinfo
	bind pub $pubqsys::undelquoteauth $pubqsys::undelquotecmd pubqsys::undelquote
	bind pub $pubqsys::forcedelquoteauth $pubqsys::forcedelquotecmd pubqsys::forcedelquote
	bind pub $pubqsys::cancelquoteauth $pubqsys::cancelquotecmd pubqsys::cancelquote
	bind evnt - prerehash pubqsys::uninstall 
	bind time - "[lindex $pubqsys::backuptime 1] [lindex $pubqsys::backuptime 0] * * *" pubqsys::backup_db
	timer $autorandquote_interval ::pubqsys::autorandquote
}


putlog "\002$pubqsys::scriptname v$pubqsys::version\002 (2010 MenzAgitat) a t charg."
